<template>
    <div>
        <div class="addresses">

            <div class="addresses-header">
                <h2>List of addresses</h2>
                <div>
                    <v-btn color="primary" @click="openCreateAddressConfirmModal()">Create new address</v-btn>
                    <v-btn color="primary" @click="openAddAddressModal()">Add existing address</v-btn>
                </div>
            </div>
            <h4>Wallet name: {{this.$route.params.name}}</h4>

            <div class="addresses-list">
                <v-card 
                    class="addresses-list__item addresses_item"
                    v-for="(address, index) in addresses"
                    :key="index"
                >
                    <v-card-title>
                        {{address.name}}
                    </v-card-title>
                    <v-card-subtitle>
                        Balance: {{address.balance | satoshiToUSD}} USD
                    </v-card-subtitle>
                </v-card>
            </div>
        </div>

        <CreateAddressModal 
            :is-open="isCreateAddressModalOpen" 
            @close-modal="createAddressHandler()" 
        />
        <AddAddressModal
            :is-open="isAddAddressModalOpen"
            @close-modal="isAddAddressModalOpen = false"
        />
    </div>
</template>

<script>
import CreateAddressModal from './modals/CreateAddressModal'
import AddAddressModal from './modals/AddAddressModal'
export default {
    components: {
        CreateAddressModal,
        AddAddressModal
    },
    data: () => ({
        isCreateAddressModalOpen: false,
        isAddAddressModalOpen: false
    }),
    created() {
        console.log(this.$route.params.name)
        this.$store.dispatch('requestAdresses', this.$route.params.name)
    },
    computed: {
        addresses() {
            return this.$store.state.wallets.find(c => c.name === this.$route.params.name)?.addresses
        }
    },
    methods: {
        openCreateAddressConfirmModal () {
            this.isCreateAddressModalOpen = true
        },
        createAddressHandler () {
            this.isCreateAddressModalOpen = false
            this.$store.dispatch('createAddressInWallet', this.$route.params.name)
        },
        openAddAddressModal() {
            this.isAddAddressModalOpen = true
        }
    },
    filters: {
        satoshiToUSD: function (value) {
            if (value == 0) return 0
            return value / 4817
        }
    }

}
</script>

<style>
    .addresses-list {
        margin: 25px 0 0;
    }

    .addresses-header {
        display: flex;
        justify-content: space-between;
    }
    
    .addresses-list__item {
        margin: 0 0 10px 0;
    }
</style>